image: golang:latest

stages:
  - test
  - fuzz

format:
  stage: test
  script:
    - go fmt
    - go vet
    - go test -race ./...

include:
  - template: Coverage-Fuzzing.gitlab-ci.yml
  - template: SAST.gitlab-ci.yml

my_fuzz_target:
    extends: .fuzz_base
    image: golang:latest
    variables:
      COVFUZZ_SEED_CORPUS: './seed_corpus'
    script:
        - apt update && apt install -y clang
        - go get -u github.com/dvyukov/go-fuzz/go-fuzz github.com/dvyukov/go-fuzz/go-fuzz-build
        - go-fuzz-build -libfuzzer -o my_fuzz_target.a .
        - clang -fsanitize=fuzzer my_fuzz_target.a -o my_fuzz_target
        - ./gitlab-cov-fuzz run --regression=$REGRESSION -- ./my_fuzz_target || true

# test MR widget
